package de.vortexhq.lobby.Utils.Data;

import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Map;

import com.google.gson.JsonObject;
import de.vortexhq.lobby.Lobby;
import de.vortexhq.lobby.Utils.ArrayHelper;
import de.vortexhq.lobby.interfaces.IDataHandler;
import netscape.javascript.JSObject;

import javax.annotation.Nullable;

public class SQLite implements IDataHandler {

    private Connection con;
    private Lobby plugin;

    public SQLite(Lobby plugin, String path) throws Exception {

        this.plugin = plugin;

        // setup connection
        try {
            this.con = connect(path);
        } catch(Exception ex) {
            throw new Exception("SQLite initailzatio failed due to exception" + ex.getLocalizedMessage(), ex.getCause());
        }
    }

    private Connection connect(String path) throws Exception{
        try {
            return DriverManager.getConnection("jdbc:sqlite:" + path);
        } catch (Exception ex) {
                throw new Exception("SQLite connection failed due to exception" + ex.getLocalizedMessage(), ex.getCause());
        }
    }

    /**
     * creates a table in the set database
     * @param name the tables name
     * @throws SQLException
     */
    @Override
    public void createTable(String name, Map<String,String> fieldMap) {
        String fields = "";

        fields += "(";
        for (Map.Entry<String, String> entry : fieldMap.entrySet()) {
            System.out.println(entry.getKey() + ":" + entry.getValue());
            fields += entry.getKey() + " " + entry.getValue();
        }
        fields += ")";

        try {
            this.con.createStatement().executeQuery("CREATE TABLE IF NOT EXISTS " + name + " " + fields);
        } catch (SQLException e) {
            e.printStackTrace();
        }
    }

    /**
     * executes a given query and returns a result of  type int
     * @param query the query to execute
     * @param a2 secondary argument used to define the required field
     * @return the found result of type int
     */
    @Override
    public int getInt(String stmt, String target) {
        try {
            int returning = 0;
            ResultSet res = this.con.createStatement().executeQuery(stmt);

            while (res.next()) {
                returning = res.getInt(target);
            }

            return returning;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return 0;
    }

    @Override
    public int[] getInts(String stmt, String target) {
        try {
            int[] returning = {};
            ResultSet res = this.con.createStatement().executeQuery(stmt);

            while (res.next()) {
                ArrayHelper.push(returning, res.getInt(target));
            }

            return returning;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public double getDouble(String stmt, @Nullable String target) {
        try {
            double returning = 0;
            ResultSet res = this.con.createStatement().executeQuery(stmt);

            while (res.next()) {
                returning = res.getDouble(target);
            }

            return returning;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return 0;
    }

    @Override
    public double[] getDoubles(String stmt, String target) {
        try {
            double[] returning = {};
            ResultSet res = this.con.createStatement().executeQuery(stmt);

            while (res.next()) {
                ArrayHelper.push(returning, res.getDouble(target));
            }

            return returning;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public String getString(String stmt, String target) {
        try {
            String returning = "";
            ResultSet res = this.con.createStatement().executeQuery(stmt);

            while (res.next()) {
                returning = res.getString(target);
            }

            return returning;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return "";
    }

    @Override
    public String[] getStrings(String stmt, String target) {
        try {
            String[] returning = {};
            ResultSet res = this.con.createStatement().executeQuery(stmt);

            while (res.next()) {
                ArrayHelper.push(returning, res.getString(target));
            }

            return returning;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return null;
    }

    @Override
    public boolean getBool(String stmt, String target) {
        try {
            boolean returning = {};
            ResultSet res = this.con.createStatement().executeQuery(stmt);

            while (res.next()) {
                returning = res.getBoolean(target);
            }

            return returning;
        } catch (SQLException e) {
            e.printStackTrace();
        }
        return false;
    }

    @Override
    public boolean[] getBools(String stmt, String target) {
        boolean[] result = {};

        try {
            ResultSet rs = this.con.createStatement().executeQuery(stmt);
            while (rs.next()) {
                result = ArrayHelper.push(result,rs.getBoolean(target));
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return result;
    }

    @Override
    public JsonObject getResultAsJSON(String a1) {
        JsonObject result = new JsonObject();

        try {
            ResultSet rs = this.con.createStatement().executeQuery(query);
            while (rs.next()) {
                // result = ArrayHelper.push(result,rs.getBoolean(target));
            }
        } catch (SQLException e) {
            e.printStackTrace();
        }

        return result;
    }

    @Override
    public JsonObject[] getResultsAsJSON(String a1) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'getResultsAsJSON'");
    }

    /**
     * executes a query and returns the unproccessed resultset
     * @param a1 the query given as a string
     * @return a resultset to continue proccessing with
     */
    @Override
    public ResultSet getResults(String a1) {
        throw new UnsupportedOperationException("Unimplemented method 'getRestuls'");
    }

    @Override
    public boolean writeData(String query, Byte[] a2, Byte[] a3) {
        throw new UnsupportedOperationException("Unimplemented method 'writeData'");
    }

    @Override
    public Map<Byte[], Byte[]> getResultsAsMap(String a1) {
        // TODO Auto-generated method stub
        throw new UnsupportedOperationException("Unimplemented method 'getResultsAsMap'");
    }
}