package de.vortexhq.lobby.Utils;

import de.vortexhq.lobby.Lobby;
import org.bukkit.ChatColor;

public class Log {
    private Lobby plugin;
    private String prefix = ChatColor.GRAY + "[ " + ChatColor.BLUE + "LOBBY" + ChatColor.GRAY + "] ";

    public Log(Lobby plugin){
        Info("Initialized Logger");
        this.plugin = plugin;
    }

    /**
     * Send a formatted info log over the plugins logger
     * @param MSG the message to log
     */
    public void Info(String MSG) {
        this.plugin.getLogger().info(prefix + ChatColor.BLUE + "INFO >> " + ChatColor.WHITE + MSG);
    }

    /**
     * Send a formatted warning log over the plugins logger
     * @param MSG the message to log
     */
    public void Warn(String MSG) {
        this.plugin.getLogger().warning(prefix + ChatColor.GOLD + "WARNING >> " + MSG);
    }

    /**
     * Send a formatted error log over the plugins logger
     * @param MSG the message to log
     */
    public void Error(String MSG) {
        this.plugin.getLogger().warning(prefix + ChatColor.RED + "ERROR >> " + MSG );
    }


    /**
     * handles reading the debugging property from config and sends a formatted debug log over the plugins logger
     * @param MSG the message to log
     */
    public void Debug(String MSG) {
        // if debug mode isn't active escape out of this function
        // if this doesn't work with performance cut debug logging all together
        if (!this.plugin.config.getBoolean("debug")) return;
        this.plugin.getLogger().info(prefix + ChatColor.GOLD + "DEBUG >> " + MSG);
    }
}
